freedombone-app-matrix 28KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792
  1. #!/bin/bash
  2. #
  3. # .---. . .
  4. # | | |
  5. # |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  6. # | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  7. # ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  8. #
  9. # Freedom in the Cloud
  10. #
  11. # matrix server
  12. #
  13. # https://raw.githubusercontent.com/silvio/docker-matrix
  14. #
  15. # License
  16. # =======
  17. #
  18. # Copyright (C) 2016-2017 Bob Mottram <bob@freedombone.net>
  19. #
  20. # This program is free software: you can redistribute it and/or modify
  21. # it under the terms of the GNU Affero General Public License as published by
  22. # the Free Software Foundation, either version 3 of the License, or
  23. # (at your option) any later version.
  24. #
  25. # This program is distributed in the hope that it will be useful,
  26. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  27. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  28. # GNU Affero General Public License for more details.
  29. #
  30. # You should have received a copy of the GNU Affero General Public License
  31. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  32. # Login username is @username:domain
  33. VARIANTS='full full-vim chat'
  34. IN_DEFAULT_INSTALL=0
  35. SHOW_ON_ABOUT=1
  36. MATRIX_DOMAIN_NAME=
  37. MATRIX_CODE=
  38. MATRIX_DATA_DIR='/var/lib/matrix'
  39. MATRIX_HTTP_PORT=8448
  40. MATRIX_ID_HTTP_PORT=8557
  41. MATRIX_PORT=8008
  42. MATRIX_ID_PORT=8081
  43. MATRIX_ONION_PORT=8109
  44. MATRIX_ID_ONION_PORT=8111
  45. MATRIX_REPO="https://github.com/matrix-org/synapse"
  46. MATRIX_COMMIT='fad3a8433535d7de321350bbd17373138c6fd3ec'
  47. SYDENT_REPO="https://github.com/matrix-org/sydent"
  48. SYDENT_COMMIT='badff2227535a3d27f14019024fb435ac2454dab'
  49. REPORT_STATS="no"
  50. MATRIX_SECRET=
  51. matrix_variables=(ONION_ONLY
  52. MY_USERNAME
  53. MATRIX_SECRET
  54. DEFAULT_DOMAIN_NAME
  55. MATRIX_DOMAIN_NAME
  56. MATRIX_CODE)
  57. function matrix_nginx {
  58. matrix_nginx_site=/etc/nginx/sites-available/$MATRIX_DOMAIN_NAME
  59. if [[ $ONION_ONLY == "no" ]]; then
  60. echo 'server {' > $matrix_nginx_site
  61. echo " listen 443 ssl;" >> $matrix_nginx_site
  62. echo " listen [::]:443 ssl;" >> $matrix_nginx_site
  63. echo " server_name ${MATRIX_DOMAIN_NAME};" >> $matrix_nginx_site
  64. echo '' >> $matrix_nginx_site
  65. echo ' # Security' >> $matrix_nginx_site
  66. function_check nginx_ssl
  67. nginx_ssl ${MATRIX_DOMAIN_NAME}
  68. function_check nginx_disable_sniffing
  69. nginx_disable_sniffing ${MATRIX_DOMAIN_NAME}
  70. echo ' add_header Strict-Transport-Security max-age=15768000;' >> $matrix_nginx_site
  71. echo '' >> $matrix_nginx_site
  72. echo ' # Logs' >> $matrix_nginx_site
  73. echo ' access_log /dev/null;' >> $matrix_nginx_site
  74. echo ' error_log /dev/null;' >> $matrix_nginx_site
  75. echo '' >> $matrix_nginx_site
  76. echo ' # Index' >> $matrix_nginx_site
  77. echo ' index index.html;' >> $matrix_nginx_site
  78. echo '' >> $matrix_nginx_site
  79. echo ' # Location' >> $matrix_nginx_site
  80. echo ' location / {' >> $matrix_nginx_site
  81. function_check nginx_limits
  82. nginx_limits ${MATRIX_DOMAIN_NAME} '15m'
  83. echo " proxy_pass http://localhost:${MATRIX_PORT}/_matrix;" >> $matrix_nginx_site
  84. echo ' proxy_set_header X-Forwarded-For $remote_addr;' >> $matrix_nginx_site
  85. echo ' }' >> $matrix_nginx_site
  86. echo '}' >> $matrix_nginx_site
  87. echo '' >> $matrix_nginx_site
  88. echo 'server {' >> $matrix_nginx_site
  89. echo " listen ${MATRIX_ID_HTTP_PORT} ssl;" >> $matrix_nginx_site
  90. echo " listen [::]:${MATRIX_ID_HTTP_PORT} ssl;" >> $matrix_nginx_site
  91. echo " server_name ${MATRIX_DOMAIN_NAME};" >> $matrix_nginx_site
  92. echo '' >> $matrix_nginx_site
  93. echo ' # Security' >> $matrix_nginx_site
  94. function_check nginx_ssl
  95. nginx_ssl ${MATRIX_DOMAIN_NAME}
  96. function_check nginx_disable_sniffing
  97. nginx_disable_sniffing ${MATRIX_DOMAIN_NAME}
  98. echo ' add_header Strict-Transport-Security max-age=15768000;' >> $matrix_nginx_site
  99. echo '' >> $matrix_nginx_site
  100. echo ' # Logs' >> $matrix_nginx_site
  101. echo ' access_log /dev/null;' >> $matrix_nginx_site
  102. echo ' error_log /dev/null;' >> $matrix_nginx_site
  103. echo '' >> $matrix_nginx_site
  104. echo ' # Index' >> $matrix_nginx_site
  105. echo ' index index.html;' >> $matrix_nginx_site
  106. echo '' >> $matrix_nginx_site
  107. echo ' # Location' >> $matrix_nginx_site
  108. echo ' location / {' >> $matrix_nginx_site
  109. function_check nginx_limits
  110. nginx_limits ${MATRIX_DOMAIN_NAME} '15m'
  111. echo " proxy_pass http://localhost:${MATRIX_ID_PORT};" >> $matrix_nginx_site
  112. echo ' proxy_set_header X-Forwarded-For $remote_addr;' >> $matrix_nginx_site
  113. echo ' }' >> $matrix_nginx_site
  114. echo '}' >> $matrix_nginx_site
  115. echo '' >> $matrix_nginx_site
  116. else
  117. echo -n '' > $matrix_nginx_site
  118. fi
  119. echo 'server {' >> $matrix_nginx_site
  120. echo " listen 127.0.0.1:$MATRIX_ONION_PORT default_server;" >> $matrix_nginx_site
  121. echo " server_name $MATRIX_DOMAIN_NAME;" >> $matrix_nginx_site
  122. echo '' >> $matrix_nginx_site
  123. function_check nginx_disable_sniffing
  124. nginx_disable_sniffing $MATRIX_DOMAIN_NAME
  125. echo '' >> $matrix_nginx_site
  126. echo ' # Logs' >> $matrix_nginx_site
  127. echo ' access_log /dev/null;' >> $matrix_nginx_site
  128. echo ' error_log /dev/null;' >> $matrix_nginx_site
  129. echo '' >> $matrix_nginx_site
  130. echo ' # Location' >> $matrix_nginx_site
  131. echo ' location / {' >> $matrix_nginx_site
  132. function_check nginx_limits
  133. nginx_limits $MATRIX_DOMAIN_NAME '15m'
  134. echo " proxy_pass http://localhost:${MATRIX_PORT}/_matrix;" >> $matrix_nginx_site
  135. echo ' proxy_set_header X-Forwarded-For $remote_addr;' >> $matrix_nginx_site
  136. echo ' }' >> $matrix_nginx_site
  137. echo '}' >> $matrix_nginx_site
  138. echo '' >> $matrix_nginx_site
  139. echo 'server {' >> $matrix_nginx_site
  140. echo " listen 127.0.0.1:$MATRIX_ID_ONION_PORT default_server;" >> $matrix_nginx_site
  141. echo " server_name $MATRIX_DOMAIN_NAME;" >> $matrix_nginx_site
  142. echo '' >> $matrix_nginx_site
  143. function_check nginx_disable_sniffing
  144. nginx_disable_sniffing $MATRIX_DOMAIN_NAME
  145. echo '' >> $matrix_nginx_site
  146. echo ' # Logs' >> $matrix_nginx_site
  147. echo ' access_log /dev/null;' >> $matrix_nginx_site
  148. echo ' error_log /dev/null;' >> $matrix_nginx_site
  149. echo '' >> $matrix_nginx_site
  150. echo ' # Location' >> $matrix_nginx_site
  151. echo ' location / {' >> $matrix_nginx_site
  152. function_check nginx_limits
  153. nginx_limits $MATRIX_DOMAIN_NAME '15m'
  154. echo " proxy_pass http://localhost:${MATRIX_ID_PORT};" >> $matrix_nginx_site
  155. echo ' proxy_set_header X-Forwarded-For $remote_addr;' >> $matrix_nginx_site
  156. echo ' }' >> $matrix_nginx_site
  157. echo '}' >> $matrix_nginx_site
  158. if [ ! -d /var/www/$MATRIX_DOMAIN_NAME ]; then
  159. mkdir -p /var/www/$MATRIX_DOMAIN_NAME/htdocs
  160. fi
  161. function_check add_ddns_domain
  162. add_ddns_domain $MATRIX_DOMAIN_NAME
  163. function_check create_site_certificate
  164. create_site_certificate $MATRIX_DOMAIN_NAME
  165. systemctl restart nginx
  166. systemctl restart turn
  167. systemctl restart matrix
  168. if [ -f /etc/systemd/system/sydent.service ]; then
  169. systemctl restart sydent
  170. fi
  171. # wait for nginx to start otherwise user add fails later
  172. sleep 5
  173. }
  174. function matrix_generate_homeserver_file {
  175. local filepath="${1}"
  176. cd /etc/matrix
  177. python -m synapse.app.homeserver \
  178. --config-path "${filepath}" \
  179. --generate-config \
  180. --report-stats ${REPORT_STATS} \
  181. --server-name ${MATRIX_DOMAIN_NAME}
  182. }
  183. function matrix_generate_identityserver_file {
  184. local filepath="${1}"
  185. cd /etc/sydent
  186. python -m sydent.sydent \
  187. --config-path "${filepath}" \
  188. --generate-config \
  189. --report-stats ${REPORT_STATS} \
  190. --server-name ${MATRIX_DOMAIN_NAME}
  191. }
  192. function matrix_configure_homeserver_yaml {
  193. local turnkey="${1}"
  194. local filepath="${2}"
  195. local ymltemp="$(mktemp)"
  196. awk -v TURNURIES="turn_uris: [\"turn:${MATRIX_DOMAIN_NAME}:${TURN_HTTP_PORT}?transport=udp\", \"turn:${DEFAULT_DOMAIN_NAME}:${TURN_HTTP_PORT}?transport=tcp\"]" \
  197. -v TURNSHAREDSECRET="turn_shared_secret: \"${turnkey}\"" \
  198. -v PIDFILE="pid_file: ${MATRIX_DATA_DIR}/homeserver.pid" \
  199. -v DATABASE="database: \"${MATRIX_DATA_DIR}/homeserver.db\"" \
  200. -v LOGFILE="log_file: \"/dev/null\"" \
  201. -v MEDIASTORE="media_store_path: \"${MATRIX_DATA_DIR}/media_store\"" \
  202. '{
  203. sub(/turn_shared_secret: "YOUR_SHARED_SECRET"/, TURNSHAREDSECRET);
  204. sub(/turn_uris: \[\]/, TURNURIES);
  205. sub(/pid_file: \/homeserver.pid/, PIDFILE);
  206. sub(/database: "\/homeserver.db"/, DATABASE);
  207. sub(/log_file: "\/homeserver.log"/, LOGFILE);
  208. sub(/media_store_path: "\/media_store"/, MEDIASTORE);
  209. print;
  210. }' "${filepath}" > "${ymltemp}"
  211. mv ${ymltemp} "${filepath}"
  212. sed -i 's|no_tls: .*|no_tls: true|g' "${filepath}"
  213. sed -i 's| tls: .*| tls: false|g' "${filepath}"
  214. sed -i 's|enable_registration_captcha.*|enable_registration_captcha: False|g' "${filepath}"
  215. sed -i "s|database: \".*|database: \"${MATRIX_DATA_DIR}/homeserver.db\"|g" "${filepath}"
  216. sed -i "s|media_store_path:.*|media_store_path: \"${MATRIX_DATA_DIR}/media_store\"|g" "${filepath}"
  217. sed -i "s|pid_file:.*|pid_file: \"${MATRIX_DATA_DIR}/homeserver.pid\"|g" "${filepath}"
  218. sed -i "s|log_file:.*|log_file: \"/dev/null\"|g" "${filepath}"
  219. sed -i 's|bind_address:.*|bind_address: 127.0.0.1|g' "${filepath}"
  220. sed -i '0,/x_forwarded:.*/s//x_forwarded: true/' "${filepath}"
  221. sed -i "s|server_name:.*|server_name: \"${MATRIX_DOMAIN_NAME}\"|g" "${filepath}"
  222. sed -i "/trusted_third_party_id_servers:/a - ${MATRIX_DOMAIN_NAME}" "${filepath}"
  223. sed -i "s|- ${MATRIX_DOMAIN_NAME}| - ${MATRIX_DOMAIN_NAME}|g" "${filepath}"
  224. sed -i "s|enable_registration:.*|enable_registration: True|g" "${filepath}"
  225. }
  226. function matrix_configure_identityserver {
  227. local filepath=/etc/sydent/sydent.conf
  228. sed -i "s|http.port.*|http.port = $MATRIX_ID_PORT|g" ${filepath}
  229. sed -i "s|db.file.*|db.file = /etc/sydent/sydent.db|g" ${filepath}
  230. sed -i "s|Sydent Validation|Freedombone Matrix Account Validation|g" ${filepath}
  231. sed -i "s|pidfile.path.*|pidfile.path = /etc/sydent/sydent.pid|g" ${filepath}
  232. sed -i "s|log.path.*|log.path = /dev/null|g" ${filepath}
  233. sed -i "s|server.name.*|server.name = ${MATRIX_DOMAIN_NAME}|g" ${filepath}
  234. }
  235. function matrix_diff {
  236. DIFFPARAMS="${DIFFPARAMS:-Naur}"
  237. MATRIX_DOMAIN_NAME="${MATRIX_DOMAIN_NAME:-demo_server_name}"
  238. REPORT_STATS="${REPORT_STATS:-no_or_yes}"
  239. export MATRIX_DOMAIN_NAME REPORT_STATS
  240. matrix_generate_synapse_file $INSTALL_DIR/homeserver.synapse.yaml
  241. diff -${DIFFPARAMS} $INSTALL_DIR/homeserver.synapse.yaml ${MATRIX_DATA_DIR}/homeserver.yaml
  242. rm $INSTALL_DIR/homeserver.synapse.yaml
  243. }
  244. function matrix_generate {
  245. breakup="0"
  246. [[ -z "${MATRIX_DOMAIN_NAME}" ]] && echo "STOP! environment variable MATRIX_DOMAIN_NAME must be set" && breakup="1"
  247. [[ -z "${REPORT_STATS}" ]] && echo "STOP! environment variable REPORT_STATS must be set to 'no' or 'yes'" && breakup="1"
  248. [[ "${breakup}" == "1" ]] && exit 1
  249. [[ "${REPORT_STATS}" != "yes" ]] && [[ "${REPORT_STATS}" != "no" ]] && \
  250. echo "STOP! REPORT_STATS needs to be 'no' or 'yes'" && breakup="1"
  251. homeserver_config=${MATRIX_DATA_DIR}/homeserver.yaml
  252. if [ -f $homeserver_config ]; then
  253. rm $homeserver_config
  254. fi
  255. matrix_generate_homeserver_file $homeserver_config
  256. matrix_configure_homeserver_yaml "${turnkey}" $homeserver_config
  257. }
  258. function remove_user_matrix {
  259. remove_username="$1"
  260. ${PROJECT_NAME}-pass -u $remove_username --rmapp matrix
  261. # TODO: There is no user removal script within synapse
  262. }
  263. function add_user_matrix {
  264. new_username="$1"
  265. new_user_password="$2"
  266. ${PROJECT_NAME}-pass -u $new_username -a matrix -p "$new_user_password"
  267. if [[ $ONION_ONLY == 'no' ]]; then
  268. retval=$(register_new_matrix_user -c ${MATRIX_DATA_DIR}/homeserver.yaml -u "${new_username}" -p "${new_user_password}" -a https://${MATRIX_DOMAIN_NAME})
  269. else
  270. retval=$(register_new_matrix_user -c ${MATRIX_DATA_DIR}/homeserver.yaml -u "${new_username}" -p "${new_user_password}" -a http://${MATRIX_DOMAIN_NAME})
  271. fi
  272. echo "0"
  273. }
  274. function install_interactive_matrix {
  275. if [ ! $ONION_ONLY ]; then
  276. ONION_ONLY='no'
  277. fi
  278. if [[ $ONION_ONLY != "no" ]]; then
  279. MATRIX_DOMAIN_NAME='matrix.local'
  280. write_config_param "MATRIX_DOMAIN_NAME" "$MATRIX_DOMAIN_NAME"
  281. else
  282. function_check interactive_site_details
  283. interactive_site_details "matrix" "MATRIX_DOMAIN_NAME" "MATRIX_CODE"
  284. if [ ! $MATRIX_DOMAIN_NAME ]; then
  285. return
  286. fi
  287. read_config_param "MATRIX_DOMAIN_NAME"
  288. read_config_param "MATRIX_CODE"
  289. fi
  290. APP_INSTALLED=1
  291. }
  292. function change_password_matrix {
  293. curr_username="$1"
  294. new_user_password="$2"
  295. #${PROJECT_NAME}-pass -u "$curr_username" -a matrix -p "$new_user_password"
  296. }
  297. function reconfigure_matrix {
  298. echo -n ''
  299. }
  300. function upgrade_matrix {
  301. if [ ! -d /etc/sydent ]; then
  302. return
  303. fi
  304. if [ ! -d /etc/matrix ]; then
  305. return
  306. fi
  307. systemctl stop turn
  308. systemctl stop matrix
  309. systemctl stop sydent
  310. function_check set_repo_commit
  311. set_repo_commit /etc/matrix "matrix commit" "$MATRIX_COMMIT" $MATRIX_REPO
  312. cd /etc/matrix
  313. pip install --upgrade --process-dependency-links .
  314. set_repo_commit /etc/sydent "sydent commit" "$SYDENT_COMMIT" $SYDENT_REPO
  315. cd /etc/sydent
  316. pip install --upgrade --process-dependency-links .
  317. sed -i 's/ssl.PROTOCOL_SSLv23/ssl.PROTOCOL_TLSv1/g' /usr/local/bin/register_new_matrix_user
  318. chown -R matrix:matrix /etc/matrix
  319. chown -R matrix:matrix /etc/sydent
  320. chown -R matrix:matrix $MATRIX_DATA_DIR
  321. pip install --upgrade --force "pynacl==0.3.0"
  322. systemctl start turn
  323. systemctl start matrix
  324. systemctl start sydent
  325. }
  326. function backup_local_matrix {
  327. source_directory=/etc/matrix
  328. if [ -d $source_directory ]; then
  329. systemctl stop turn
  330. systemctl stop matrix
  331. systemctl stop sydent
  332. function_check backup_directory_to_usb
  333. backup_directory_to_usb $source_directory matrix
  334. source_directory=$MATRIX_DATA_DIR
  335. if [ -d $source_directory ]; then
  336. backup_directory_to_usb $source_directory matrixdata
  337. fi
  338. source_directory=/etc/sydent
  339. if [ -d $source_directory ]; then
  340. backup_directory_to_usb $source_directory matrixid
  341. fi
  342. systemctl start turn
  343. systemctl start matrix
  344. systemctl start sydent
  345. fi
  346. }
  347. function restore_local_matrix {
  348. if [ -d /etc/matrix ]; then
  349. systemctl stop turn
  350. systemctl stop matrix
  351. systemctl stop sydent
  352. temp_restore_dir=/root/tempmatrix
  353. function_check restore_directory_from_usb
  354. restore_directory_from_usb $temp_restore_dir matrix
  355. cp -r $temp_restore_dir/etc/matrix/* /etc/matrix
  356. if [ ! "$?" = "0" ]; then
  357. function_check backup_unmount_drive
  358. backup_unmount_drive
  359. exit 3783
  360. fi
  361. rm -rf $temp_restore_dir
  362. chown -R matrix:matrix /etc/matrix
  363. temp_restore_dir=/root/tempmatrixdata
  364. restore_directory_from_usb $temp_restore_dir matrixdata
  365. cp -r $temp_restore_dir$MATRIX_DATA_DIR/* $MATRIX_DATA_DIR
  366. if [ ! "$?" = "0" ]; then
  367. function_check backup_unmount_drive
  368. backup_unmount_drive
  369. exit 78352
  370. fi
  371. rm -rf $temp_restore_dir
  372. chown -R matrix:matrix $MATRIX_DATA_DIR
  373. temp_restore_dir=/root/tempmatrixid
  374. restore_directory_from_usb $temp_restore_dir matrixid
  375. cp -r $temp_restore_dir/etc/sydent/* /etc/sydent
  376. if [ ! "$?" = "0" ]; then
  377. function_check backup_unmount_drive
  378. backup_unmount_drive
  379. exit 29562
  380. fi
  381. rm -rf $temp_restore_dir
  382. chown -R matrix:matrix /etc/sydent
  383. systemctl start turn
  384. systemctl start matrix
  385. systemctl start sydent
  386. fi
  387. }
  388. function backup_remote_matrix {
  389. source_directory=/etc/matrix
  390. if [ -d $source_directory ]; then
  391. systemctl stop turn
  392. systemctl stop matrix
  393. systemctl stop sydent
  394. function_check backup_directory_to_friend
  395. backup_directory_to_friend $source_directory matrix
  396. source_directory=$MATRIX_DATA_DIR
  397. if [ -d $source_directory ]; then
  398. backup_directory_to_friend $source_directory matrixdata
  399. fi
  400. source_directory=/etc/sydent
  401. if [ -d $source_directory ]; then
  402. backup_directory_to_friend $source_directory matrixid
  403. fi
  404. systemctl start turn
  405. systemctl start matrix
  406. systemctl start sydent
  407. fi
  408. }
  409. function restore_remote_matrix {
  410. if [ -d /etc/matrix ]; then
  411. systemctl stop turn
  412. systemctl stop matrix
  413. systemctl stop sydent
  414. temp_restore_dir=/root/tempmatrix
  415. function_check restore_directory_from_friend
  416. restore_directory_from_friend $temp_restore_dir matrix
  417. cp -r $temp_restore_dir/etc/matrix/* /etc/matrix
  418. if [ ! "$?" = "0" ]; then
  419. exit 38935
  420. fi
  421. rm -rf $temp_restore_dir
  422. chown -R matrix:matrix /etc/matrix
  423. temp_restore_dir=/root/tempmatrixdata
  424. restore_directory_from_friend $temp_restore_dir matrixdata
  425. cp -r $temp_restore_dir$MATRIX_DATA_DIR/* $MATRIX_DATA_DIR
  426. if [ ! "$?" = "0" ]; then
  427. exit 60923
  428. fi
  429. rm -rf $temp_restore_dir
  430. chown -R matrix:matrix $MATRIX_DATA_DIR
  431. temp_restore_dir=/root/tempmatrixid
  432. restore_directory_from_friend $temp_restore_dir matrixid
  433. cp -r $temp_restore_dir/etc/sydent/* /etc/sydent
  434. if [ ! "$?" = "0" ]; then
  435. exit 738356
  436. fi
  437. rm -rf $temp_restore_dir
  438. chown -R matrix:matrix /etc/sydent
  439. systemctl start turn
  440. systemctl start matrix
  441. systemctl start sydent
  442. fi
  443. }
  444. function remove_matrix {
  445. #firewall_remove ${MATRIX_HTTP_PORT}
  446. nginx_dissite $MATRIX_DOMAIN_NAME
  447. remove_certs $MATRIX_DOMAIN_NAME
  448. if [ -f /etc/nginx/sites-available/$MATRIX_DOMAIN_NAME ]; then
  449. rm /etc/nginx/sites-available/$MATRIX_DOMAIN_NAME
  450. fi
  451. if [ ! -d /var/www/$MATRIX_DOMAIN_NAME ]; then
  452. rm -rf /var/www/$MATRIX_DOMAIN_NAME
  453. fi
  454. function_check remove_ddns_domain
  455. remove_ddns_domain $MATRIX_DOMAIN_NAME
  456. systemctl stop matrix
  457. if [ -f /etc/systemd/system/sydent.service ]; then
  458. systemctl stop sydent
  459. fi
  460. function_check remove_turn
  461. remove_turn
  462. systemctl disable matrix
  463. if [ -f /etc/systemd/system/sydent.service ]; then
  464. systemctl disable sydent
  465. rm /etc/systemd/system/sydent.service
  466. fi
  467. if [ -f /etc/systemd/system/matrix.service ]; then
  468. rm /etc/systemd/system/matrix.service
  469. fi
  470. apt-get -y remove --purge coturn
  471. cd /etc/matrix
  472. pip uninstall .
  473. if [ -d /etc/sydent ]; then
  474. cd /etc/sydent
  475. pip uninstall .
  476. rm -rf /etc/sydent
  477. fi
  478. rm -rf $MATRIX_DATA_DIR
  479. rm -rf /etc/matrix
  480. deluser matrix
  481. delgroup matrix
  482. remove_onion_service matrix ${MATRIX_ONION_PORT}
  483. remove_onion_service matrix ${MATRIX_ID_ONION_PORT}
  484. #sed -i "/# Matrix Server/,/# End of Matrix Server/d" /etc/nginx/sites-available/${MATRIX_DOMAIN_NAME}
  485. systemctl restart nginx
  486. remove_completion_param install_matrix
  487. sed -i '/matrix/d' $COMPLETION_FILE
  488. }
  489. function install_identity_server {
  490. if [ ! -d /etc/sydent ]; then
  491. function_check git_clone
  492. git_clone $SYDENT_REPO /etc/sydent
  493. if [ ! -d /etc/sydent ]; then
  494. echo $'Unable to clone sydent repo'
  495. exit 936525
  496. fi
  497. fi
  498. cd /etc/sydent
  499. git checkout $SYDENT_COMMIT -b $SYDENT_COMMIT
  500. set_completion_param "sydent commit" "$SYDENT_COMMIT"
  501. if [ ! -d $INSTALL_DIR/sydent ]; then
  502. mkdir -p $INSTALL_DIR/sydent
  503. fi
  504. if [ -d $INSTALL_DIR/sydent ]; then
  505. rm -rf $INSTALL_DIR/sydent/*
  506. fi
  507. sed -i "s|8090|${MATRIX_ID_PORT}|g" /etc/sydent/sydent/sydent.py
  508. python setup.py install
  509. pip install --upgrade --process-dependency-links . -b $INSTALL_DIR/sydent
  510. if [ ! "$?" = "0" ]; then
  511. echo $'Failed to install matrix identity server'
  512. exit 798362
  513. fi
  514. #function_check matrix_generate_identityserver_file
  515. #matrix_generate_identityserver_file /etc/sydent/sydent.conf
  516. #if [ ! -f /etc/sydent/sydent.conf ]; then
  517. # echo $'Matrix identity server configuration not generated'
  518. # exit 72528
  519. #fi
  520. #function_check matrix_configure_identityserver
  521. #matrix_configure_identityserver
  522. chmod -R 700 /etc/sydent/sydent.conf
  523. chown -R matrix:matrix /etc/sydent
  524. echo '[Unit]' > /etc/systemd/system/sydent.service
  525. echo 'Description=Sydent Matrix identity server' >> /etc/systemd/system/sydent.service
  526. echo 'After=network.target nginx.target' >> /etc/systemd/system/sydent.service
  527. echo '' >> /etc/systemd/system/sydent.service
  528. echo '[Service]' >> /etc/systemd/system/sydent.service
  529. echo 'Type=simple' >> /etc/systemd/system/sydent.service
  530. echo 'User=matrix' >> /etc/systemd/system/sydent.service
  531. echo "WorkingDirectory=/etc/sydent" >> /etc/systemd/system/sydent.service
  532. echo "ExecStart=/usr/bin/python -m sydent.sydent --config-path /etc/sydent/sydent.conf --report-stats ${REPORT_STATS} --server-name ${MATRIX_DOMAIN_NAME}" >> /etc/systemd/system/sydent.service
  533. echo 'Restart=always' >> /etc/systemd/system/sydent.service
  534. echo 'RestartSec=10' >> /etc/systemd/system/sydent.service
  535. echo '' >> /etc/systemd/system/sydent.service
  536. echo '[Install]' >> /etc/systemd/system/sydent.service
  537. echo 'WantedBy=multi-user.target' >> /etc/systemd/system/sydent.service
  538. systemctl enable sydent
  539. systemctl daemon-reload
  540. systemctl start sydent
  541. sleep 5
  542. if [ ! -f /etc/sydent/sydent.conf ]; then
  543. echo $'Matrix identity server config was not generated'
  544. exit 82352
  545. fi
  546. if [ ! -f /etc/sydent/sydent.db ]; then
  547. echo $'No matrix identity server database was created'
  548. exit 7354383
  549. fi
  550. chmod -R 700 /etc/sydent/sydent.db
  551. }
  552. function install_home_server {
  553. if [ ! -d /etc/matrix ]; then
  554. function_check git_clone
  555. git_clone $MATRIX_REPO /etc/matrix
  556. if [ ! -d /etc/matrix ]; then
  557. echo $'Unable to clone matrix repo'
  558. exit 6724683
  559. fi
  560. fi
  561. cd /etc/matrix
  562. git checkout $MATRIX_COMMIT -b $MATRIX_COMMIT
  563. set_completion_param "matrix commit" "$MATRIX_COMMIT"
  564. if [ ! -d $INSTALL_DIR/matrix ]; then
  565. mkdir -p $INSTALL_DIR/matrix
  566. fi
  567. rm -rf /usr/local/lib/python2.7/dist-packages/ldap*
  568. if [ -d $INSTALL_DIR/matrix ]; then
  569. rm -rf $INSTALL_DIR/matrix/*
  570. fi
  571. pip install --upgrade --process-dependency-links . -b $INSTALL_DIR/matrix
  572. if [ ! "$?" = "0" ]; then
  573. echo $'Failed to install matrix home server'
  574. exit 782542
  575. fi
  576. if [ ! -d $MATRIX_DATA_DIR ]; then
  577. mkdir $MATRIX_DATA_DIR
  578. fi
  579. groupadd matrix
  580. useradd -c "Matrix system account" -d $MATRIX_DATA_DIR -m -r -g matrix matrix
  581. function_check install_turn
  582. install_turn
  583. MATRIX_SECRET="${turnkey}"
  584. function_check matrix_generate
  585. matrix_generate
  586. if [[ -z ${MATRIX_DATA_DIR}/homeserver.yaml ]]; then
  587. echo $'homeserver.yaml is zero size'
  588. exit 783724
  589. fi
  590. # Disable the web client
  591. sed -i 's|web_client:.*|web_client: False|g' $MATRIX_DATA_DIR/homeserver.yaml
  592. if ! grep "#- webclient" $MATRIX_DATA_DIR/homeserver.yaml; then
  593. sed -i 's|- webclient.*|#- webclient|g' $MATRIX_DATA_DIR/homeserver.yaml
  594. fi
  595. sed -i 's|, webclient||g' $MATRIX_DATA_DIR/homeserver.yaml
  596. chmod -R 700 $MATRIX_DATA_DIR/homeserver.yaml
  597. chown -R matrix:matrix /etc/matrix
  598. chown -R matrix:matrix $MATRIX_DATA_DIR
  599. sed -i 's/ssl.PROTOCOL_SSLv23/ssl.PROTOCOL_TLSv1/g' /usr/local/bin/register_new_matrix_user
  600. echo '[Unit]' > /etc/systemd/system/matrix.service
  601. echo 'Description=Synapse Matrix homeserver' >> /etc/systemd/system/matrix.service
  602. echo 'After=network.target nginx.target' >> /etc/systemd/system/matrix.service
  603. echo '' >> /etc/systemd/system/matrix.service
  604. echo '[Service]' >> /etc/systemd/system/matrix.service
  605. echo 'Type=simple' >> /etc/systemd/system/matrix.service
  606. echo 'User=matrix' >> /etc/systemd/system/matrix.service
  607. echo "WorkingDirectory=/etc/matrix" >> /etc/systemd/system/matrix.service
  608. echo "ExecStart=/usr/bin/python -m synapse.app.homeserver --config-path ${MATRIX_DATA_DIR}/homeserver.yaml" >> /etc/systemd/system/matrix.service
  609. echo 'Restart=always' >> /etc/systemd/system/matrix.service
  610. echo 'RestartSec=10' >> /etc/systemd/system/matrix.service
  611. echo '' >> /etc/systemd/system/matrix.service
  612. echo '[Install]' >> /etc/systemd/system/matrix.service
  613. echo 'WantedBy=multi-user.target' >> /etc/systemd/system/matrix.service
  614. systemctl enable matrix
  615. systemctl daemon-reload
  616. systemctl start matrix
  617. # wait for the database to be created
  618. sleep 5
  619. if [ ! -f $MATRIX_DATA_DIR/homeserver.db ]; then
  620. echo $'No matrix home server database was created'
  621. exit 23782
  622. fi
  623. chmod -R 700 $MATRIX_DATA_DIR/homeserver.db
  624. MATRIX_ONION_HOSTNAME=$(add_onion_service matrix ${MATRIX_PORT} ${MATRIX_ONION_PORT})
  625. MATRIX_ID_ONION_HOSTNAME=$(add_onion_service matrixid ${MATRIX_ID_PORT} ${MATRIX_ID_ONION_PORT})
  626. if [ ! ${MATRIX_PASSWORD} ]; then
  627. if [ -f ${IMAGE_PASSWORD_FILE} ]; then
  628. MATRIX_PASSWORD="$(printf `cat $IMAGE_PASSWORD_FILE`)"
  629. else
  630. MATRIX_PASSWORD="$(create_password ${MINIMUM_PASSWORD_LENGTH})"
  631. fi
  632. fi
  633. #firewall_add matrix ${MATRIX_HTTP_PORT}
  634. rm -rf ${MATRIX_DATA_DIR}/Maildir
  635. rm -rf ${MATRIX_DATA_DIR}/.mutt
  636. rm -f ${MATRIX_DATA_DIR}/.muttrc
  637. rm -f ${MATRIX_DATA_DIR}/.mutt-alias
  638. rm -f ${MATRIX_DATA_DIR}/.procmailrc
  639. rm -f ${MATRIX_DATA_DIR}/.emacs-mutt
  640. }
  641. function install_matrix {
  642. if [ ! -d $INSTALL_DIR ]; then
  643. mkdir -p $INSTALL_DIR
  644. fi
  645. if [[ ${ONION_ONLY} == 'no' ]]; then
  646. if [ ! -f /etc/ssl/certs/${MATRIX_DOMAIN_NAME}.pem ]; then
  647. echo $'Obtaining certificate for the main domain'
  648. create_site_certificate ${MATRIX_DOMAIN_NAME} 'yes'
  649. fi
  650. fi
  651. export DEBIAN_FRONTEND=noninteractive
  652. apt-get -yq install coreutils \
  653. curl file gcc git libevent-2.0-5 \
  654. libevent-dev libffi-dev libffi6 \
  655. libgnutls28-dev libjpeg62-turbo \
  656. libjpeg62-turbo-dev libldap-2.4-2 \
  657. libldap2-dev libsasl2-dev \
  658. libsqlite3-dev libssl-dev \
  659. libssl1.0.0 libtool libxml2 \
  660. libxml2-dev libxslt1-dev libxslt1.1 \
  661. make python python-dev \
  662. python-pip python-psycopg2 \
  663. python-virtualenv sqlite unzip \
  664. zlib1g zlib1g-dev
  665. pip install --upgrade pip
  666. pip install --upgrade python-ldap
  667. pip install --upgrade lxml
  668. function_check install_home_server
  669. install_home_server
  670. #function_check install_identity_server
  671. #install_identity_server
  672. function_check update_default_domain
  673. update_default_domain
  674. pip install --upgrade --force "pynacl==0.3.0"
  675. function_check matrix_nginx
  676. matrix_nginx
  677. #if [[ $(add_user_matrix "${MY_USERNAME}" "${MATRIX_PASSWORD}" | tail -n 1) != "0" ]]; then
  678. # echo $'Failed to add matrix admin user';
  679. # exit 879352
  680. #fi
  681. APP_INSTALLED=1
  682. }